﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
'Provided by BeneBarros on 1/24/2015
Sub Class_Globals
	Private fx As JFX
	Private FileListStart As Int
	Private raf As RandomAccessFile
	Private bc As ByteConverter
	Type imInfo(imType As Int, imWidth As Int, imHeight As Int)
	Public Height As Int
	Public Width As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub TestImage(Dir As String, NameFile As String) As Boolean
   	Private SizeADD As Int
	Private FileBuf() As Byte
   	Private Pos As Long
	raf.Initialize(Dir,NameFile,True)
	SizeADD=raf.Size
	Private FileBuf(SizeADD) As Byte
	raf.ReadBytes(FileBuf,0,SizeADD,0)
	raf.Close 
	Dim ImageInfo As imInfo = getImageInfo(FileBuf)
	If ImageInfo.imType<>0 Then
		Height = ImageInfo.imHeight
		Width = ImageInfo.imWidth
		Log("Type :" & ImageInfo.imType)
		Log("Height :" & ImageInfo.imHeight) 
		Log("Width :" & ImageInfo.imWidth)
		Return True
	End If
	Return False
End Sub
Private Sub getImageInfo(bBuf() As Byte) As imInfo 
' This is the sub to call to retrieve information on a file.
    ' Byte array buffer to store part of the file
    ' Set all properties to default values
	'Dim tmp(bbuf.Length ) As Short 
	'tmp =bc.ShortsFromBytes(bBuf)
	'bBuf=bc.ShortsToBytes (tmp)
	Dim iinfo As imInfo 
	Private  bt(1) As Byte 
	iinfo.imType = 0
	iinfo.imWidth = 0
	iinfo.imHeight = 0
	Dim hBuf As String 
	'itUNKNOWN = 0
    'itGIF = 1
    'itJPEG = 2
    'itPNG = 3
    'itBMP = 4

    ' here we will load the first part of a file into a byte
'array the amount of the file stored here depends on
'the BUFFERSIZE constant
	Dim bt(3) As Byte 
	For i=0 To 2
		bt(i) = bBuf(i+1)
	Next
	hBuf = bc.HexFromBytes(bt)
	If hBuf = "504E47" Then
	  	' this is a PNG file
		iinfo.imType  = 3
		' get the width
		iinfo.imWidth  = Mult(bBuf(19), bBuf(18))
		' get the height
		iinfo.imHeight = Mult(bBuf(23), bBuf(22))
    	Return iinfo
    End If
	Dim bt(3) As Byte 
	For i=0 To 2
		bt(i) = bBuf(i)
	Next
	hBuf = bc.HexFromBytes(bt)	
    If hBuf = "474946" Then
    ' this is a GIF file
		iinfo.imType = 1
		' get the width
		iinfo.imWidth = Mult(bBuf(6), bBuf(7))

		' get the height
		iinfo.imHeight = Mult(bBuf(8), bBuf(9))
    	Return iinfo
    End If
    If bBuf(0) = 66 AND bBuf(1) = 77 Then 
    ' this is a BMP file
		iinfo.imType = 4
		' get the width
		iinfo.imWidth = Mult(bBuf(18), bBuf(19))

		' get the height
		iinfo.imHeight = Mult(bBuf(22), bBuf(23))
    	Return iinfo
    End If
    If iinfo.imType = 0 Then
    ' if the file is not one of the above type then
    ' check to see if it is a JPEG file
        Dim lPos,lPos1 As Int
        
        Do Until lPos > bBuf.Length  - 10
        ' loop through looking for the byte sequence FF,D8,FF
        ' which marks the begining of a JPEG file
        ' lPos will be left at the postion of the start
            If (bBuf(lPos) = -1 AND bBuf(lPos + 1) = -40 AND bBuf(lPos + 2) = -1) OR (lPos >= bBuf.Length  - 10) Then 
				lPos1 = lPos 
				lPos = bBuf.Length 
            Else
            	' move our pointer up
            	lPos = lPos + 1
            End If
        ' and continue
        Loop
        lPos = lPos1
        lPos = lPos + 2
        If lPos >= bBuf.Length - 10 Then Return iinfo
        Do Until lPos > bBuf.Length  - 10
			' loop through the markers until we find the one
			'starting with FF,C0 which is the block containing the
			'image information
        
            Do Until lPos > bBuf.Length  - 10
            ' loop until we find the beginning of the next marker
                If bBuf(lPos) = -1 AND bBuf(lPos + 1) <> -1 Then 
					lPos1=lPos
					lPos= bBuf.Length
				Else
                	lPos = lPos + 1
                	If lPos >= bBuf.Length - 10 Then Return iinfo
				End If
            Loop
            lPos=lPos1
            ' move pointer up
            lPos = lPos + 1
			Dim bt(1) As Byte 
			bt(0)=bBuf(lPos)
            hBuf = bc.HexFromBytes(bt)
        	If "C0-C1-C2-C3-C5-C6-C7-C9-CA-CB-CD-CE-CF".Contains(hBuf) Then
			' we found the right block
				lPos1=lPos
                lPos= bBuf.Length
        	Else
            	' otherwise keep looking
            	lPos = lPos + Mult(bBuf(lPos + 2), bBuf(lPos + 1))
            	' check for end of buffer
            	If lPos >= bBuf.Length - 10 Then Return iinfo
        	End If    
        Loop
        lPos=lPos1
        ' If we've gotten this far it is a JPEG and we are ready
        ' to grab the information.
        iinfo.imType = 2
        ' get the height
        iinfo.imHeight = Mult(bBuf(lPos + 5), bBuf(lPos + 4))
        
        ' get the width
        iinfo.imWidth = Mult(bBuf(lPos + 7), bBuf(lPos + 6))
    	Return iinfo
    End If
End Sub
Private Sub Mult(lsb As Byte, msb As Byte) As Int
	Dim l, m As Int 
	l=Bit.ParseInt(lsb,10)
	m=Bit.ParseInt (msb,10)
	If l<0 Then l = l + 256
	If m<0 Then m = m + 256
	Return l + (m * 256)
End Sub
